#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include <time.h>

#include "novas.h"

void compute_and_print_distace_to_the_two_tracking_stations_geocenter_and_elevations_for_a_given_date_unixsec(time_t target_date_unixsec, time_t orbit_point_time_unixsec, int orbit_point_inp_year, int orbit_point_inp_month, int orbit_point_inp_day, int orbit_point_inp_hour, int orbit_point_inp_min, double orbit_point_inp_sec, double orbit_point_X, double orbit_point_Y, double orbit_point_Z, double orbit_point_dX, double orbit_point_dY, double orbit_point_dZ){

  short int year;
  short int month;
  short int day;
  const short int leap_secs = 37; // = 33;
  const short int accuracy = 0;  
  short int error = 0;
   
  double hour;
   
  // dummy EOP
  double ut1_utc = 0.0; // heah, silly, I know
  const double x_pole = 0.0;
  const double y_pole = 0.0;
  //
  double jd_utc, jd_ut1, delta_t, vter[3], vcel[3];

  double X, Y, Z, dX, dY, dZ;

  double distance_to_GB_km, distance_to_PU_km, distance_to_Geocenter_km;
  
  double vcel_ts_to_satellite[3],zenith_angle_at_ts_rad,zenith_angle_at_ts_deg,elevation_at_PU_deg,elevation_at_GB_deg;
  
  double timediff_double;

  X=orbit_point_X;
  Y=orbit_point_Y;
  Z=orbit_point_Z;
  dX=orbit_point_dX;
  dY=orbit_point_dY;
  dZ=orbit_point_dZ;

  

   // I'm not toching this - below is the legacy code
   year=(short int)orbit_point_inp_year;
   month=(short int)orbit_point_inp_month;
   day=(short int)orbit_point_inp_day;
   hour=(double)orbit_point_inp_hour+(double)orbit_point_inp_min/60.0+(double)orbit_point_inp_sec/3600.0;

  // Linear interpolation between the orbit data point and the requeste time point
  if( target_date_unixsec != orbit_point_time_unixsec ){
   timediff_double=(double)(target_date_unixsec-orbit_point_time_unixsec);
   //fprintf(stderr,"timediff_double=%lf %ld %ld  hour=%lf orbit_point_inp_min=%d orbit_point_inp_sec=%lf\n",timediff_double,orbit_point_time_unixsec,target_date_unixsec,hour,orbit_point_inp_min,orbit_point_inp_sec);
   // Sign???? seems correct now for target_date_unixsec-orbit_point_time_unixsec
   X=X+dX*timediff_double;
   Y=Y+dY*timediff_double;
   Z=Z+dZ*timediff_double;
   //fprintf(stderr,"%lf %lf %lf\n",X,Y,Z);
  }

  
/*
   Establish time arguments.
*/ 
   jd_utc = julian_date(year,month,day,hour);
   jd_ut1 = jd_utc + ut1_utc / 86400.0;
   delta_t = 32.184 + leap_secs - ut1_utc;
   
   // Green Bank
   vter[0] =  882879.84013/1000.0;
   vter[1] = -4924482.30801/1000.0;
   vter[2] =  3944130.68519/1000.0;      
/*      
   Transform vector to GCRS.
*/
   if ((error = ter2cel(jd_ut1,0.0,delta_t,1,accuracy,0,x_pole,y_pole,vter,
      vcel)) != 0)
   {
      printf ("Error %d from ter2cel.", error);
      exit(error);
   }

   distance_to_GB_km=sqrt( (X-vcel[0])*(X-vcel[0])+(Y-vcel[1])*(Y-vcel[1])+(Z-vcel[2])*(Z-vcel[2]) );                                                                  
   
   // Compute the elevation

   vcel_ts_to_satellite[0]=X-vcel[0];
   vcel_ts_to_satellite[1]=Y-vcel[1];
   vcel_ts_to_satellite[2]=Z-vcel[2];
   // Manually reset vcel to the direction of local zenith
   vter[0] = cos(38.4378236021*M_PI/180.0) * cos(280.1642206548*M_PI/180.0);
   vter[1] = cos(38.4378236021*M_PI/180.0) * sin(280.1642206548*M_PI/180.0);
   vter[2] = sin(38.4378236021*M_PI/180.0);
   ter2cel(jd_ut1,0.0,delta_t,1,accuracy,0,x_pole,y_pole,vter,vcel);
   //
   zenith_angle_at_ts_rad=acos( (vcel[0]*vcel_ts_to_satellite[0] + vcel[1]*vcel_ts_to_satellite[1] + vcel[2]*vcel_ts_to_satellite[2])/(distance_to_GB_km*sqrt(vcel[0]*vcel[0]+vcel[1]*vcel[1]+vcel[2]*vcel[2])) );
   zenith_angle_at_ts_deg=zenith_angle_at_ts_rad*180/M_PI;
   elevation_at_GB_deg=90.0-zenith_angle_at_ts_deg;
   

   // Push
   vter[0] = 2916948.887/1000.0;
   vter[1] = 2248648.243/1000.0;
   vter[2] = 5190099.798/1000.0;
/*      
   Transform vector to GCRS.
*/
   if ((error = ter2cel (jd_ut1,0.0,delta_t,1,accuracy,0,x_pole,y_pole,vter,
      vcel)) != 0)
   {
      printf ("Error %d from ter2cel.", error);
      exit(error);
   }

   distance_to_PU_km=sqrt( (X-vcel[0])*(X-vcel[0])+(Y-vcel[1])*(Y-vcel[1])+(Z-vcel[2])*(Z-vcel[2]) );

   // Compute the elevation
   
   vcel_ts_to_satellite[0]=X-vcel[0];
   vcel_ts_to_satellite[1]=Y-vcel[1];
   vcel_ts_to_satellite[2]=Z-vcel[2];
   // DEBUG
   //double ra,dec;
   //vector2radec(vcel_ts_to_satellite,&ra,&dec);
   //fprintf(stderr,"Apparent position of the sattelite @PU: %lf %lf\n",ra,dec);
   //fprintf(stderr,"distance to PU %lf km\n",distance_to_PU_km);
   // Manually reset vcel to the direction of local zenith
   vter[0] = cos(54.8206222223*M_PI/180.0) * cos(37.6282888834*M_PI/180.0);
   vter[1] = cos(54.8206222223*M_PI/180.0) * sin(37.6282888834*M_PI/180.0);
   vter[2] = sin(54.8206222223*M_PI/180.0);
   ter2cel(jd_ut1,0.0,delta_t,1,accuracy,0,x_pole,y_pole,vter,vcel);
   //
   zenith_angle_at_ts_rad=acos( (vcel[0]*vcel_ts_to_satellite[0] + vcel[1]*vcel_ts_to_satellite[1] + vcel[2]*vcel_ts_to_satellite[2])/(distance_to_PU_km*sqrt(vcel[0]*vcel[0]+vcel[1]*vcel[1]+vcel[2]*vcel[2])) );
   zenith_angle_at_ts_deg=zenith_angle_at_ts_rad*180/M_PI;
   elevation_at_PU_deg=90.0-zenith_angle_at_ts_deg;


   distance_to_Geocenter_km=sqrt(X*X+Y*Y+Z*Z);
   
   fprintf(stdout,"%13lf %13lf %13lf   %+5.1lf %+5.1lf \n",distance_to_GB_km,distance_to_PU_km,distance_to_Geocenter_km,elevation_at_GB_deg,elevation_at_PU_deg);
                                                                  

}

int main(int argc, char **argv){

  char orbitfilename[512];
  FILE *orbitfile;

  int inp_year, inp_month, inp_day, inp_hour, inp_min;
  double X, Y, Z, dX, dY, dZ, inp_sec;
  double distance_to_Geocenter_km;

  int best_inp_year, best_inp_month, best_inp_day, best_inp_hour, best_inp_min;
  double best_X, best_Y, best_Z, best_dX, best_dY, best_dZ, best_inp_sec;


  time_t experiment_start_unixsec,experiment_stop_unixsec,orbit_point_time_unixsec,best_orbit_point_time_unixsec,target_timepoint_unixsec,timedif_unixsec;
  struct tm structureTIME;
  double best_distance_to_Geocenter_km=1e10;
  time_t best_timedif=8640000;
  
  if( argc!=2 && argc!=3 && argc!=4 ){fprintf(stderr,"Usage: %s RA140225-161120.org  # compute distances and elevations in each line of the input orbit file\n  or\n       %s RA140225-161120.org 1478232000 1478235600 # compute distance and elevations for the smallest geocentric distance within the specified timerange\n",argv[0],argv[0]);exit(1);}
  
  if( argc==4 ){
   target_timepoint_unixsec=0;
   experiment_start_unixsec=atol(argv[2]);
   experiment_stop_unixsec=atol(argv[3]);
   target_timepoint_unixsec=0;
  }
  if( argc==3 ){
   target_timepoint_unixsec=atol(argv[2]);
   experiment_start_unixsec=target_timepoint_unixsec-1800;
   experiment_stop_unixsec=target_timepoint_unixsec+1800;
  }
  if( argc==2 ){
   target_timepoint_unixsec=experiment_start_unixsec=experiment_stop_unixsec=0;
  }

  strcpy(orbitfilename,argv[1]);  
  orbitfile=fopen(orbitfilename,"rw");
  if(NULL==orbitfile){fprintf(stderr,"Error opening orbit file %s \n",orbitfilename);exit(1);}

  //while(-1<fscanf(orbitfile,"%d-%d-%dT%d:%d:%lf %lf %lf %lf %lf %lf %lf",&inp_year,&inp_month,&inp_day,&inp_hour,&inp_min,&inp_sec,&X,&Y,&Z,&dX,&dY,&dZ)){
  while(12==fscanf(orbitfile,"%d-%d-%dT%d:%d:%lf %lf %lf %lf %lf %lf %lf",&inp_year,&inp_month,&inp_day,&inp_hour,&inp_min,&inp_sec,&X,&Y,&Z,&dX,&dY,&dZ)){

   // Convert time of this orbital point to uixsec
   structureTIME.tm_sec = (int)inp_sec;
   structureTIME.tm_min = (int)inp_min;
   structureTIME.tm_hour = (int)inp_hour;
   structureTIME.tm_mday = (int)inp_day;
   structureTIME.tm_mon = (int)inp_month - 1;
   structureTIME.tm_year = (int)inp_year - 1900;
   orbit_point_time_unixsec = timegm(&structureTIME);           
    
   // Check if we want to compute distance for this time
   if( experiment_start_unixsec!=0 ){ 

    if( orbit_point_time_unixsec<experiment_start_unixsec )continue;
    if( orbit_point_time_unixsec>experiment_stop_unixsec )break;
    if( target_timepoint_unixsec==0 ){
     // We are searching for the smallest geocentric distance
     distance_to_Geocenter_km=sqrt(X*X+Y*Y+Z*Z);
     if( distance_to_Geocenter_km<best_distance_to_Geocenter_km ){
      best_distance_to_Geocenter_km=distance_to_Geocenter_km;
      best_inp_year=inp_year;best_inp_month=inp_month;best_inp_day=inp_day;best_inp_hour=inp_hour;best_inp_min=inp_min;best_inp_sec=inp_sec;
      best_X=X;best_Y=Y;best_Z=Z;best_dX=dX;best_dY=dY;best_dZ=dZ;
      best_orbit_point_time_unixsec=orbit_point_time_unixsec;
     }
    }
    else{
     // We are searching for the orbit point_hearest to the specified time
     timedif_unixsec=labs(target_timepoint_unixsec-orbit_point_time_unixsec);
     //fprintf(stderr,"%ld %ld %ld  best_timedif=%ld\n",target_timepoint_unixsec,orbit_point_time_unixsec,timedif_unixsec,best_timedif);
     if( timedif_unixsec<best_timedif ){
      best_timedif=timedif_unixsec;
      best_inp_year=inp_year;best_inp_month=inp_month;best_inp_day=inp_day;best_inp_hour=inp_hour;best_inp_min=inp_min;best_inp_sec=inp_sec;
      best_X=X;best_Y=Y;best_Z=Z;best_dX=dX;best_dY=dY;best_dZ=dZ;
      best_orbit_point_time_unixsec=orbit_point_time_unixsec;
     }
     // And small optimization considering that the orbit is sorted in time
     if( orbit_point_time_unixsec>target_timepoint_unixsec )break;
    }

   }
   else{
    // Run computations for all points
    compute_and_print_distace_to_the_two_tracking_stations_geocenter_and_elevations_for_a_given_date_unixsec( orbit_point_time_unixsec, orbit_point_time_unixsec, inp_year, inp_month, inp_day, inp_hour, inp_min, inp_sec, X, Y, Z, dX, dY, dZ);
   }

 }

 fclose(orbitfile);

 if( experiment_start_unixsec!=0 ){
  // Compute only the best point
  if( target_timepoint_unixsec==0 )target_timepoint_unixsec=best_orbit_point_time_unixsec;
  compute_and_print_distace_to_the_two_tracking_stations_geocenter_and_elevations_for_a_given_date_unixsec( target_timepoint_unixsec, best_orbit_point_time_unixsec, best_inp_year, best_inp_month, best_inp_day, best_inp_hour, best_inp_min, best_inp_sec, best_X, best_Y, best_Z, best_dX, best_dY, best_dZ);
 }


 return 0;
}
